package com.xunmei.system.service;

import java.util.Date;
import java.util.List;
import java.util.Map;

import com.xunmei.common.core.utils.Ymd;
import com.xunmei.system.api.domain.SysWorkTime;
import com.baomidou.mybatisplus.extension.service.IService;
import com.xunmei.common.core.web.page.TableDataInfo;
import com.xunmei.system.domain.SysWorkTimeSet;

/**
 * 【作息】Service接口
 *
 * @author xunmei
 * @date 2023-08-14
 */
public interface ISysWorkTimeService extends IService<SysWorkTime> {

    /**
     *
     * @param orgId
     * @param ymd
     * @param isEnable
     * @return
     */
    SysWorkTime findWorkTimeByYmd(Long orgId, Ymd ymd, boolean isEnable);

    SysWorkTime selectSysWorkTimeById(String id);

    List<Long> findOrgIdsByYmd(String toYmd);

    void handleTodayChanged(List<Long> orgIdList, List<SysWorkTime> workTimeList, List<SysWorkTime> exists, Date today);

    List<SysWorkTime> findByYmd(List<Long> orgIds, Date ymd);

    List<SysWorkTime> findByOrgAndMonth(SysWorkTime sysWorkTime);

    List<SysWorkTime> batchnew(Long orgId, List<SysWorkTime> workTimeDtoList);

    boolean existByYmd(Long orgId, Ymd ymd, boolean isEnable);

    /**
     * 查询【作息】列表
     *
     * @param sysWorkTime 【作息】
     * @return 【作息】集合
     */
    List<SysWorkTime> selectSysWorkTimeList(SysWorkTime sysWorkTime);

    /**
     * 新增【作息】
     *
     * @param sysWorkTime 【作息】
     * @return 结果
     */
    int insertSysWorkTime(SysWorkTime sysWorkTime);

    /**
     * 修改【作息】
     *
     * @param sysWorkTime 【作息】
     * @return 结果
     */
    int updateSysWorkTime(SysWorkTime sysWorkTime);

    /**
     * 批量删除【作息】
     *
     * @param ids 需要删除的【作息】主键集合
     * @return 结果
     */
    int deleteSysWorkTimeByIds(String[] ids);

    /**
     * 删除【作息】信息
     *
     * @param id 【作息】主键
     * @return 结果
     */
    int deleteSysWorkTimeById(String id);

    /**
     * 查询【作息】分页数据
     *
     * @param sysWorkTime 查询条件对象
     * @return Page
     */
    TableDataInfo<SysWorkTime> selectPage(SysWorkTime sysWorkTime);

    Map<String, Object> checkData(SysWorkTimeSet sysWorkTime);
}
